<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="input-element">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
    <p>[[currentValue]]</p>
    <fieldset>
      <label for="input">[[label]]</label>
      <input type="text" id="input" placeholder$="[[placeholder]]" on-input="inputHandler" value="{{currentValue::input}}">
    </fieldset>
  </template>

  <script>
    /**
     * `input-element`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class InputElement extends Polymer.Element {
      static get is() { return 'input-element'; }
      static get properties() {
        return {
          label: {
            type: String,
            value: 'Input-value'
          },
          placeholder: {
            type: String,
            value: 'ingresa texto...'
          },
          currentValue: {
            type: String,
            notify: true
          }
        };
      }
      inputHandler(e) {
        console.log('On-input event: ', e);
        this.dispatchEvent(new CustomEvent('custom-input', {
          bubbles: true,
          composed: true
        }));
      }

      constructor() {
        super();
        this.addEventListener('current-value-changed', (e) => {
          console.log('evento lanzado con la propiedad \'current-value-changed\'', e);
        })
      }
    }

    window.customElements.define(InputElement.is, InputElement);
  </script>
</dom-module>
